package es.rickyepoderi.sample;

import javax.annotation.Resource;
import javax.annotation.security.DeclareRoles;
import javax.annotation.security.PermitAll;
import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import org.apache.cxf.annotations.Policy;
import org.apache.cxf.interceptor.InInterceptors;
import org.jboss.ws.api.annotation.EndpointConfig;

@Stateless
@WebService(name = "echo", 
        targetNamespace = "http://es.rickyepoderi.sample/ws", 
        serviceName = "echo-service")
@Policy(placement = Policy.Placement.BINDING, uri = "WssX509V3Token10.xml")
@DeclareRoles("Users")
@SOAPBinding(style = SOAPBinding.Style.RPC)
@EndpointConfig(configFile = "WEB-INF/jaxws-endpoint-config.xml", configName = "Custom WS-Security Endpoint")
@InInterceptors(interceptors = {
    "es.rickyepoderi.sample.CertificateBinaryTokenInterceptor"
})
public class Echo {

    @Resource SessionContext ctx;

    @WebMethod
    @PermitAll
    public String echo(String input) {
        System.err.println("RICKY: principal: " + ctx.getCallerPrincipal());
        System.err.println("RICKY: principal: " + ctx.getCallerPrincipal().getClass());
        System.err.println("RICKY: isCallerInRole: " + ctx.isCallerInRole("Users"));
        return ctx.getCallerPrincipal() + " -> " +  input;
    }
}